data:extend(
{
  {
    type = "recipe",
    name = "basic-oil-processing",
    category = "oil-processing",
    enabled = false,
    energy_required = 3,
    ingredients =
    {
      {type="fluid", name="crude-oil", amount=3}
    },
    results=
    {
	{type="fluid", name="heavy-oil", amount=1},
      {type="fluid", name="light-oil", amount=1},
      {type="fluid", name="petroleum-gas", amount=1}
	  },
    icon = "__base__/graphics/icons/fluid/basic-oil-processing.png",
    subgroup = "fluid",
    order = "a[oil-processing]-a[basic-oil-processing]"
  },

  {
    type = "recipe",
    name = "advanced-oil-processing",
    category = "oil-processing",
    enabled = false,
    energy_required = 6,
    ingredients =
    {{type="fluid", name="water", amount=3},
      {type="fluid", name="crude-oil", amount=3}},
    results=
    {{type="fluid", name="heavy-oil", amount=2},
      {type="fluid", name="light-oil", amount=2},
      {type="fluid", name="petroleum-gas", amount=2}},
    icon = "__base__/graphics/icons/fluid/advanced-oil-processing.png",
    subgroup = "fluid",
    order = "a[oil-processing]-b[advanced-oil-processing]"
  },

  {
    type = "recipe",
    name = "heavy-oil-cracking",
    category = "chemistry",
    enabled = false,
	energy_required = 2,
    ingredients =
    {{type="fluid", name="water", amount=1},
      {type="fluid", name="heavy-oil", amount=1}},
    results=
    {{type="fluid", name="light-oil", amount=2}},
    main_product= "",
    icon = "__base__/graphics/icons/fluid/heavy-oil-cracking.png",
    subgroup = "fluid",
    order = "b[fluid-chemistry]-a[heavy-oil-cracking]"
  },

  {
    type = "recipe",
    name = "light-oil-cracking",
    category = "chemistry",
    enabled = false,
	energy_required = 2,
    ingredients =
    {{type="fluid", name="water", amount=1},
      {type="fluid", name="light-oil", amount=1}},
    results=
    {{type="fluid", name="petroleum-gas", amount=2}},
    main_product= "",
    icon = "__base__/graphics/icons/fluid/light-oil-cracking.png",
    subgroup = "fluid",
    order = "b[fluid-chemistry]-b[light-oil-cracking]"
  },

  {
    type = "recipe",
    name = "sulfuric-acid",
    category = "chemistry",
    enabled = false,	
    energy_required = 1,
    ingredients =
    {{type="item", name="sulfur", amount=1},
      {type="fluid", name="water", amount=1}},
    results=
    {{type="fluid", name="sulfuric-acid", amount=2}}
  },

  {
    type = "recipe",
    name = "plastic-bar",
    category = "crafting-with-fluid",
    enabled = false,	
    energy_required = 1,	
    ingredients =
    {{type="item", name="coal", amount=1},
	{type="fluid", name="petroleum-gas", amount=1}},
    results=
    {{type="item", name="plastic-bar", amount=1}},
  },
  
  {
    type = "recipe",
    name = "solid-fuel-from-light-oil",
    category = "crafting-with-fluid",
    enabled = false,	
    energy_required = 2,	
    ingredients =
    {{type="fluid", name="light-oil", amount=2}},
    results=
    {{type="item", name="solid-fuel", amount=1}},
    icon = "__base__/graphics/icons/solid-fuel-from-light-oil.png",
    subgroup = "fluid",
    enabled = "false",
    order = "b[fluid-chemistry]-c[solid-fuel-from-light-oil]"
  },

  {
    type = "recipe",
    name = "solid-fuel-from-petroleum-gas",
    category = "crafting-with-fluid",
    enabled = false,	
    energy_required = 3,
    ingredients =
    {{type="fluid", name="petroleum-gas", amount=3}},
    results=
    {{type="item", name="solid-fuel", amount=1}},
    icon = "__base__/graphics/icons/solid-fuel-from-petroleum-gas.png",
    subgroup = "fluid",
    enabled = "false",
    order = "b[fluid-chemistry]-d[solid-fuel-from-petroleum-gas]"
  },

  {
    type = "recipe",
    name = "solid-fuel-from-heavy-oil",
    category = "crafting-with-fluid",
    enabled = false,	
    energy_required = 1,
    ingredients =
    {{type="fluid", name="heavy-oil", amount=1}},
    results=
    {{type="item", name="solid-fuel", amount=1}},
    icon = "__base__/graphics/icons/solid-fuel-from-heavy-oil.png",
    subgroup = "fluid",
    enabled = "false",
    order = "b[fluid-chemistry]-e[solid-fuel-from-heavy-oil]"
  },


  {
    type = "recipe",
    name = "sulfur",
    category = "crafting-with-fluid",
    energy_required = 1,
    enabled = false,
    ingredients =
    {{type="item", name="coal", amount=1},
      {type="fluid", name="petroleum-gas", amount=1}},
    results=
    {{type="item", name="sulfur", amount=1}}
  },

  {
    type = "recipe",
    name = "lubricant",
    category = "chemistry",
    enabled = false,
    energy_required = 2,
    ingredients =
    {{type="fluid", name="light-oil", amount=2}},
    results=
    {{type="fluid", name="lubricant", amount=2}}
  },

  {
    type = "recipe",
    name = "empty-barrel",
    category = "crafting",
    energy_required = 1,
    subgroup = "barrel",
    enabled = false,
    ingredients =
    {{type="item", name="steel-plate", amount=6},},
    results=
    {{type="item", name="empty-barrel", amount=1}}
  },

  {
    type = "recipe",
    name = "fill-crude-oil-barrel",
    category = "crafting-with-fluid",
    energy_required = 1,
    subgroup = "barrel",
    order = "b[fill-crude-oil-barrel]",
    enabled = false,
    icon = "__base__/graphics/icons/fluid/fill-crude-oil-barrel.png",
    ingredients =
    {{type="fluid", name="crude-oil", amount=10},
      {type="item", name="empty-barrel", amount=1},},
    results=
    {{type="item", name="crude-oil-barrel", amount=1}}
  },

  {
    type = "recipe",
    name = "empty-crude-oil-barrel",
    category = "crafting-with-fluid",
    energy_required = 1,
    subgroup = "barrel",
    order = "c[empty-crude-oil-barrel]",
    enabled = false,
    icon = "__base__/graphics/icons/fluid/empty-crude-oil-barrel.png",
    ingredients =
    {{type="item", name="crude-oil-barrel", amount=1}},
    results=
    {{type="fluid", name="crude-oil", amount=10},
      {type="item", name="empty-barrel", amount=1}}
  },

  {
    type = "recipe",
    name = "flame-thrower-ammo",
    category = "crafting-with-fluid",
    enabled = false,
    ingredients =
    {{type="item", name="iron-plate", amount=1},
    {type="fluid", name="petroleum-gas", amount=1}},
    result = "flame-thrower-ammo"
  }
})
